function [H,f]=Hstar(T,alf,gamma,Q0,xi,We,n, G1, vnew, Md)
GV=Md\(G1*vnew);
for i=1:n
    Txx=T(i); Tyy=T(i+n); Tzz=T(i+2*n);  
    Txy=T(i+3*n); Txz=T(i+4*n); Tyz=T(i+5*n);
    Tn=[Txx, Txy, Txz;
        Txy, Tyy, Tyz;
        Txz, Tyz, Tzz];
    Gxx=GV(i); Gyy=GV(i+n); Gzz=GV(i+2*n);  
    Gxy=GV(i+3*n); Gxz=GV(i+4*n); Gyz=GV(i+5*n);
    gv=[Gxx, Gxy, Gxz;
        Gxy, Gyy, Gyz;
        Gxz, Gyz, Gzz];
    %%=======
    lam=sqrt(1+1/(3*xi)*(trace(Tn)));
    ff=1;%2/gamma*(1-1/lam)*exp(Q0*(lam-1))+1/lam^2*(1-alf/(3*xi^2)*trace(Tn*Tn));
    hh=-1/We*(xi*(ff-1)*eye(3)+alf/xi*(Tn*Tn));
    gvt=(gv*Tn+Tn*gv');
    rH=hh+gvt; 

    H(i,1)=rH(1,1);
    H(i+n,1)=rH(2,2);
    H(i+2*n,1)=rH(3,3); 
    H(i+3*n,1)=(rH(2,1)+rH(1,2))/2;
    H(i+4*n,1)=(rH(3,1)+rH(1,3))/2;
    H(i+5*n,1)=(rH(3,2)+rH(2,3))/2;
    f(i,1)=ff;
end
end