function [mv,v,T1,p,nn]=P2G(Ng,icon,xpn,nep,np,vp,pp,Tp)
% zero arrays
mv=zeros(Ng,1);
pv=zeros(Ng,3);
v=zeros(Ng,3);
Tv=zeros(Ng,6);
nn=zeros(Ng,1);
p=zeros(Ng,1);
%%% map velocities to grid
for ip=1:np
    i=nep(ip);
    iv=icon(:,i);
    n=shape3D(xpn(1,ip),xpn(2,ip),xpn(3,ip));
    mv(iv)=mv(iv)+n;
%     nodePressure(iv)=nodePressure(iv)+mp(ip)*sigp(1,ip)*n;
    pv(iv,:)=pv(iv,:)+[vp(1,ip)*n,vp(2,ip)*n,vp(3,ip)*n];
    Tv(iv,:)=Tv(iv,:)+[Tp(ip,1)*n,Tp(ip,2)*n,Tp(ip,3)*n,Tp(ip,4)*n,Tp(ip,5)*n,Tp(ip,6)*n];
    nn(iv,1)=1;%nn(iv,1)+n;
    p(iv,1)=p(iv,:) + pp(ip)*n;
end
index1=find(mv>=1.e-14);
index0=find(mv< 1.e-14);
v(index1,1)=pv(index1,1)./mv(index1);
v(index1,2)=pv(index1,2)./mv(index1);
v(index1,3)=pv(index1,3)./mv(index1);

tv(index1,1)=Tv(index1,1)./mv(index1);
tv(index1,2)=Tv(index1,2)./mv(index1);
tv(index1,3)=Tv(index1,3)./mv(index1);
tv(index1,4)=Tv(index1,4)./mv(index1);
tv(index1,5)=Tv(index1,5)./mv(index1);
tv(index1,6)=Tv(index1,6)./mv(index1);

p(index1)=p(index1)./mv(index1);

p(index0)=0;

v(index0,1)=0;
v(index0,2)=0;
v(index0,3)=0;

tv(index0,1)=0;
tv(index0,2)=0;
tv(index0,3)=0;
tv(index0,4)=0;
tv(index0,5)=0;
tv(index0,6)=0;
%%%
v = [v(:,1);v(:,2);v(:,3)];
T1=[tv(:,1);tv(:,2);tv(:,3);tv(:,4);tv(:,5);tv(:,6)];
