function [mv,v,a,vg, ag, T, Tg, dT, dTg, p,nn]=P2G(Ng,icon,xpn,nep,np,vpp, app, Tpp, ap, vp,Tp, dTp, dTpp, pp) 
% zero arrays  
mv=zeros(Ng,1);
pv=zeros(Ng,3); pa=zeros(Ng,3);
pvg=zeros(Ng,3); pag=zeros(Ng,3);
v=zeros(Ng,3);  a=zeros(Ng,3);
Tv=zeros(Ng,6); Tvg=zeros(Ng,6);
dTv=zeros(Ng,6); dTvg=zeros(Ng,6);
at=zeros(Ng,3);vt=zeros(Ng,3);Tg=zeros(Ng,6); dTg=zeros(Ng,6); 
p=zeros(Ng,1);nn=zeros(Ng,1);
%%% map velocities to grid
for ip=1:np
    i=nep(ip);
    iv=icon(:,i);
    n=shape3D(xpn(1,ip),xpn(2,ip),xpn(3,ip));
    mv(iv)=mv(iv)+n;
%     nodePressure(iv)=nodePressure(iv)+mp(ip)*sigp(1,ip)*n;
    pv(iv,:)=pv(iv,:)+[vp(1,ip)*n,vp(2,ip)*n,vp(3,ip)*n];
    pvg(iv,:)=pvg(iv,:)+[vpp(1,ip)*n,vpp(2,ip)*n,vpp(3,ip)*n];
    pa(iv,:)=pa(iv,:)+[ap(1,ip)*n,ap(2,ip)*n,ap(3,ip)*n];
    pag(iv,:)=pag(iv,:)+[app(1,ip)*n,app(2,ip)*n,app(3,ip)*n];

    Tv(iv,:)=Tv(iv,:)+[Tp(ip,1)*n,Tp(ip,2)*n,Tp(ip,3)*n,Tp(ip,4)*n,Tp(ip,5)*n,Tp(ip,6)*n];
    Tvg(iv,:)=Tvg(iv,:)+[Tpp(ip,1)*n,Tpp(ip,2)*n,Tpp(ip,3)*n,Tpp(ip,4)*n,Tpp(ip,5)*n,Tpp(ip,6)*n];
    
    dTv(iv,:)=dTv(iv,:)+[dTp(ip,1)*n,dTp(ip,2)*n, dTp(ip,3)*n, dTp(ip,4)*n, dTp(ip,5)*n, dTp(ip,6)*n];
    dTvg(iv,:)=dTvg(iv,:)+[dTpp(ip,1)*n,dTpp(ip,2)*n, dTpp(ip,3)*n, dTpp(ip,4)*n, dTpp(ip,5)*n, dTpp(ip,6)*n];
    
    nn(iv,1)=1;%nn(iv,1)+n;
    p(iv,1)=p(iv,:) + pp(ip)*n;
end
index1=find(mv>=1.e-14);
index0=find(mv< 1.e-14);
v(index1,1)=pv(index1,1)./mv(index1);
v(index1,2)=pv(index1,2)./mv(index1);
v(index1,3)=pv(index1,3)./mv(index1);

vt(index1,1)=pvg(index1,1)./mv(index1);
vt(index1,2)=pvg(index1,2)./mv(index1);
vt(index1,3)=pvg(index1,3)./mv(index1);

a(index1,1)=pa(index1,1)./mv(index1);
a(index1,2)=pa(index1,2)./mv(index1);
a(index1,3)=pa(index1,3)./mv(index1);

at(index1,1)=pag(index1,1)./mv(index1);
at(index1,2)=pag(index1,2)./mv(index1);
at(index1,3)=pag(index1,3)./mv(index1);

tv(index1,1)=Tv(index1,1)./mv(index1);
tv(index1,2)=Tv(index1,2)./mv(index1);
tv(index1,3)=Tv(index1,3)./mv(index1);
tv(index1,4)=Tv(index1,4)./mv(index1);
tv(index1,5)=Tv(index1,5)./mv(index1);
tv(index1,6)=Tv(index1,6)./mv(index1);

ttv(index1,1)=Tvg(index1,1)./mv(index1);
ttv(index1,2)=Tvg(index1,2)./mv(index1);
ttv(index1,3)=Tvg(index1,3)./mv(index1);
ttv(index1,4)=Tvg(index1,4)./mv(index1);
ttv(index1,5)=Tvg(index1,5)./mv(index1);
ttv(index1,6)=Tvg(index1,6)./mv(index1);

dtv(index1,1)=dTv(index1,1)./mv(index1);
dtv(index1,2)=dTv(index1,2)./mv(index1);
dtv(index1,3)=dTv(index1,3)./mv(index1);
dtv(index1,4)=dTv(index1,4)./mv(index1);
dtv(index1,5)=dTv(index1,5)./mv(index1);
dtv(index1,6)=dTv(index1,6)./mv(index1);

dttv(index1,1)=dTvg(index1,1)./mv(index1);
dttv(index1,2)=dTvg(index1,2)./mv(index1);
dttv(index1,3)=dTvg(index1,3)./mv(index1);
dttv(index1,4)=dTvg(index1,4)./mv(index1);
dttv(index1,5)=dTvg(index1,5)./mv(index1);
dttv(index1,6)=dTvg(index1,6)./mv(index1);





p(index1)=p(index1)./mv(index1);

p(index0)=0;

v(index0,1)=0;
v(index0,2)=0;
v(index0,3)=0;
vt(index0,1)=0;
vt(index0,2)=0;
vt(index0,3)=0;
a(index0,1)=0;
a(index0,2)=0;
a(index0,3)=0;
at(index0,1)=0;
at(index0,2)=0;
at(index0,3)=0;

tv(index0,1)=0;
tv(index0,2)=0;
tv(index0,3)=0;
tv(index0,4)=0;
tv(index0,5)=0;
tv(index0,6)=0;
ttv(index0,1)=0;
ttv(index0,2)=0;
ttv(index0,3)=0;
ttv(index0,4)=0;
ttv(index0,5)=0;
ttv(index0,6)=0;

dtv(index0,1)=0;
dtv(index0,2)=0;
dtv(index0,3)=0;
dtv(index0,4)=0;
dtv(index0,5)=0;
dtv(index0,6)=0;
dttv(index0,1)=0;
dttv(index0,2)=0;
dttv(index0,3)=0;
dttv(index0,4)=0;
dttv(index0,5)=0;
dttv(index0,6)=0;
%%%
a = [a(:,1);a(:,2);a(:,3)];ag=[at(:,1);at(:,2);at(:,3)];
v = [v(:,1);v(:,2);v(:,3)];vg=[vt(:,1);vt(:,2);vt(:,3)];
T=[tv(:,1);tv(:,2);tv(:,3);tv(:,4);tv(:,5);tv(:,6)];
Tg=[ttv(:,1);ttv(:,2);ttv(:,3);ttv(:,4);ttv(:,5);ttv(:,6)];
dT=[dtv(:,1);dtv(:,2);dtv(:,3);dtv(:,4);dtv(:,5);dtv(:,6)];
dTg=[dttv(:,1);dttv(:,2);dttv(:,3);dttv(:,4);dttv(:,5);dttv(:,6)];
