function [xp,vp,ap, dTp, Tp, pp]=maptopointsPC(np,nep,xpn,icon,Ng,xp,vp,ap,dTp,Tp,Vgt,Agt,dAg,Tgt,dTgt,ddTgt,dt,L1,L2,L3,L4,L5,alp,p)
Ap1=0*ap; Ap2=0*ap;
Vp1=0*vp; Vp2=0*vp;
Tp1=0*Tp; Tp2=0*Tp;
dTp1=0*dTp; dTp2=0*dTp;
B=zeros(np,4);
for ip=1:np
    i=nep(ip);
    iv=icon(:,i);
    %n=N0(ip,:);
    n=shape3D(xpn(1,ip),xpn(2,ip),xpn(3,ip));
    
    Vp1(1,ip) = Vgt(iv,1)'*n;  Ap1(1,ip) = Agt(iv,1)'*n;
    Vp1(2,ip) = Vgt(iv,2)'*n;  Ap1(2,ip) = Agt(iv,2)'*n;
    Vp1(3,ip) = Vgt(iv,3)'*n;  Ap1(3,ip) = Agt(iv,3)'*n;
    
    T1 = Tgt(iv,1)'*n;  dT1 = dTgt(iv,1)'*n;
    T2 = Tgt(iv,2)'*n;  dT2 = dTgt(iv,2)'*n;
    T3 = Tgt(iv,3)'*n;  dT3 = dTgt(iv,3)'*n;
    T4 = Tgt(iv,4)'*n;  dT4 = dTgt(iv,4)'*n; 
    T5 = Tgt(iv,5)'*n;  dT5 = dTgt(iv,5)'*n;
    T6 = Tgt(iv,6)'*n;  dT6 = dTgt(iv,6)'*n; 
        
     Vp2(1,ip)=vp(1,ip)+L4*dt*ap(1,ip)+L5*dt*n'*dAg(iv,1);
     Vp2(2,ip)=vp(2,ip)+L4*dt*ap(2,ip)+L5*dt*n'*dAg(iv,2);
     Vp2(3,ip)=vp(3,ip)+L4*dt*ap(3,ip)+L5*dt*n'*dAg(iv,3);
     Ap2(1,ip)=ap(1,ip)+n'*dAg(iv,1);
     Ap2(2,ip)=ap(2,ip)+n'*dAg(iv,2);
     Ap2(3,ip)=ap(3,ip)+n'*dAg(iv,3);
     
     Ts1 = Tp(ip,1)+L4*dt*dTp(ip,1)+L5*dt*ddTgt(iv,1)'*n;
     Ts2 = Tp(ip,2)+L4*dt*dTp(ip,2)+L5*dt*ddTgt(iv,2)'*n;
     Ts3 = Tp(ip,3)+L4*dt*dTp(ip,3)+L5*dt*ddTgt(iv,3)'*n;          
     Ts4 = Tp(ip,4)+L4*dt*dTp(ip,4)+L5*dt*ddTgt(iv,4)'*n;
     Ts5 = Tp(ip,5)+L4*dt*dTp(ip,5)+L5*dt*ddTgt(iv,5)'*n;
     Ts6 = Tp(ip,6)+L4*dt*dTp(ip,6)+L5*dt*ddTgt(iv,6)'*n;
     
     dTs1 = dTp(ip,1) + ddTgt(iv,1)'*n;
     dTs2 = dTp(ip,2) + ddTgt(iv,2)'*n;
     dTs3 = dTp(ip,3) + ddTgt(iv,3)'*n;          
     dTs4 = dTp(ip,4) + ddTgt(iv,4)'*n;
     dTs5 = dTp(ip,5) + ddTgt(iv,5)'*n;
     dTs6 = dTp(ip,6) + ddTgt(iv,6)'*n;
     
     xp(1,ip)=xp(1,ip) + L1* vp(1,ip) *dt + L2*ap(1,ip)*dt^2 + L3*n'*dAg(iv,1)*dt^2;
     xp(2,ip)=xp(2,ip) + L1* vp(2,ip) *dt + L2*ap(2,ip)*dt^2 + L3*n'*dAg(iv,2)*dt^2;
     xp(3,ip)=xp(3,ip) + L1* vp(3,ip) *dt + L2*ap(3,ip)*dt^2 + L3*n'*dAg(iv,3)*dt^2;
     Tp1(ip,:) = [T1, T2, T3, T4, T5, T6];  
     Tp2(ip,:) = [Ts1, Ts2, Ts3, Ts4, Ts5, Ts6];  
     dTp1(ip,:) = [dT1, dT2, dT3, dT4, dT5, dT6];  
     dTp2(ip,:) = [dTs1, dTs2, dTs3, dTs4, dTs5, dTs6]; 
     nPressure = p(iv);
     pp(ip) = nPressure'*n; 
     
     %%======   
end
ap=Ap1*alp+(1-alp)*Ap2;
vp=Vp1*alp+(1-alp)*Vp2;
Tp=Tp1*alp+(1-alp)*Tp2;
dTp=dTp1*alp+(1-alp)*dTp2;
end



% [xpn,nep]=natcoords(xp,dx,xmin,nexyz);
% 
% vnew = [vnew(1:Ng,:),vnew(Ng+1:2*Ng,:),vnew(2*Ng+1:3*Ng,:)];
% v = [v(1:Ng,:),v(Ng+1:2*Ng,:),v(2*Ng+1:3*Ng,:)];
% pp = zeros(Np,1); Tp=zeros(Np,6); xpF = zeros(3,Np);
% k1=zeros(3,Np); k2=zeros(3,Np); k3=zeros(3,Np); k4=zeros(3,Np);
% 
% %%% RK4
% for ip=1:Np
%     i=nep(ip);
%     iv=icon(:,i);
%     n=shape3D(xpn(1,ip),xpn(2,ip),xpn(3,ip));
%     
%     k1(1,ip) = v(iv,1)'*n; 
%     k1(2,ip) = v(iv,2)'*n;
%     k1(3,ip) = v(iv,3)'*n;
%     xpF(1,ip) = xp(1,ip) +  k1(1,ip) *dt/2;
%     xpF(2,ip) = xp(2,ip) +  k1(2,ip) *dt/2;  
%     xpF(3,ip) = xp(3,ip) +  k1(3,ip) *dt/2; 
%     [xpn2,nep2] = natcoords(xpF(:,ip),dx,xmin,nexyz);
%     i2 = nep2(1); iv2 = icon(:,i2); nn = shape3D(xpn2(1),xpn2(2),xpn2(3));
%     k2(1,ip) = 0.5*(vnew(iv2,1)+v(iv2,1))'*nn;
%     k2(2,ip) = 0.5*(vnew(iv2,2)+v(iv2,2))'*nn;
%     k2(3,ip) = 0.5*(vnew(iv2,3)+v(iv2,3))'*nn;
%     
%     xpF(1,ip) = xp(1,ip) +  k2(1,ip) *dt/2;
%     xpF(2,ip) = xp(2,ip) +  k2(2,ip) *dt/2;   
%     xpF(3,ip) = xp(3,ip) +  k2(3,ip) *dt/2;  
%     [xpn2,nep2] = natcoords(xpF(:,ip),dx,xmin,nexyz);
%     i2 = nep2(1); iv2 = icon(:,i2); nn = shape3D(xpn2(1),xpn2(2),xpn2(3));
%     k3(1,ip) = 0.5*(vnew(iv2,1)+v(iv2,1))'*nn;
%     k3(2,ip) = 0.5*(vnew(iv2,2)+v(iv2,2))'*nn;
%     k3(3,ip) = 0.5*(vnew(iv2,3)+v(iv2,3))'*nn;
%     
%     xpF(1,ip) = xp(1,ip) +  k3(1,ip) *dt;
%     xpF(2,ip) = xp(2,ip) +  k3(2,ip) *dt;
%     xpF(3,ip) = xp(3,ip) +  k3(3,ip) *dt;
%     [xpn2,nep2] = natcoords(xpF(:,ip),dx,xmin,nexyz);
%     i2 = nep2(1); iv2 = icon(:,i2); nn = shape3D(xpn2(1),xpn2(2),xpn2(3));
%     k4(1,ip) = vnew(iv2,1)'*nn;
%     k4(2,ip) = vnew(iv2,2)'*nn;
%     k4(3,ip) = vnew(iv2,3)'*nn;
%     
%     xp(1,ip) = xp(1,ip) + dt*(k1(1,ip)/6 + k2(1,ip)/3 + k3(1,ip)/3 + k4(1,ip)/6);
%     xp(2,ip) = xp(2,ip) + dt*(k1(2,ip)/6 + k2(2,ip)/3 + k3(2,ip)/3 + k4(2,ip)/6);
%     xp(3,ip) = xp(3,ip) + dt*(k1(3,ip)/6 + k2(3,ip)/3 + k3(3,ip)/3 + k4(3,ip)/6)+1/2*g/Fr^2*dt^2;
% 
% 
%    vp(1,ip)=(k1(1,ip)/6 + k2(1,ip)/3 + k3(1,ip)/3 + k4(1,ip)/6);
%    vp(2,ip)=(k1(2,ip)/6 + k2(2,ip)/3 + k3(2,ip)/3 + k4(2,ip)/6);
%    vp(3,ip)=(k1(3,ip)/6 + k2(3,ip)/3 + k3(3,ip)/3 + k4(3,ip)/6)+g/Fr^2*dt;
%    
%     %%% Update stress
%     nPressure = p(iv);
%     pp(ip) = nPressure'*n;  
%     T1=Tg(iv)'*n;
%     T2=Tg(iv+Ng)'*n;
%     T3=Tg(iv+2*Ng)'*n;
%     T4=Tg(iv+3*Ng)'*n;
%     T5=Tg(iv+4*Ng)'*n;
%     T6=Tg(iv+5*Ng)'*n; 
%     Tp(ip,:) = [T1, T2, T3, T4, T5, T6];  
% end
% end
% 
