function [pSupportDOF,vimposedTDof,pFreeDOF,vSupportDOF,vFreeDOF,vBC,pressureBC,qn]=bcSetup(Nn,x,gravity,rhoWater,nbot,ntop,nleft,nright)


pSupportDOF = ntop(round(length(ntop)/2));
pFreeDOF = setdiff(1:Nn,pSupportDOF);

%vxSuportDOF = [nleft,nright];
%vySupportDOF=[ntop+Nn,nbot+Nn,nleft+Nn,nright+Nn];
vxSuportDOF = [nleft,nright];
vySupportDOF=[nbot,nbot+Nn];

vimposedDOF = ntop(2:end-1);
vimposedTDof=[nbot,nbot+Nn,nbot+2*Nn];
vSupportDOF = [vimposedDOF,vxSuportDOF,vySupportDOF];
vFreeDOF = setdiff(1:2*Nn,vSupportDOF);
% end

% Initialize BCs
pressureBC=zeros(Nn,1);
pressureBC(pSupportDOF)=0;
vBC = zeros(2*Nn,1);
vBC(vimposedDOF)=0;
qn=zeros(Nn,1);
%%% end

% %%%  cavity Flow pressure on TOP and BOTTOM velocities
% pSupportDOF = ntop(2:end-1);
% pFreeDOF = setdiff(1:Nn,pSupportDOF);
% 
% vxSuportDOF = [nleft,nright];
% vySupportDOF=[ntop+Nn,nbot+Nn];
% vimposedDOF = [ntop(2:end-1),nbot(2:end-1)];
% 
% vSupportDOF = [vxSuportDOF,vySupportDOF,vimposedDOF];
% vFreeDOF = setdiff(1:2*Nn,vSupportDOF);
% % end
% 
% % Initialize BCs
% pressureBC=zeros(Nn,1);
% pressureBC(pSupportDOF)=0;
% vBC = zeros(2*Nn,1);
% vBC(vimposedDOF)=0.1;
% qn=zeros(Nn,1);
% %%% end

% %%%  cavity Flow pressure on TOP TINKERED
% pSupportDOF = ntop(2:end-1);
% pFreeDOF = setdiff(1:Nn,pSupportDOF);
% 
% vxSuportDOF = [nleft(2:end-1),nright(2:end-1)];
% vySupportDOF=[ntop(2:end-1)+Nn,nbot(2:end-1)+Nn];
% vimposedDOF = ntop;
% 
% vSupportDOF = [vxSuportDOF,vySupportDOF,vimposedDOF];
% vFreeDOF = setdiff(1:2*Nn,vSupportDOF);
% % end
% 
% % Initialize BCs
% pressureBC=zeros(Nn,1);
% pressureBC(pSupportDOF)=0;
% vBC = zeros(2*Nn,1);
% vBC(vimposedDOF)=0.1;
% qn=zeros(Nn,1);
% %%% end

% %  cavity Flow pressure on RIGHT
% pSupportDOF = nright;
% pFreeDOF = setdiff(1:Nn,pSupportDOF);
% 
% vxSuportDOF = [nleft,nright];
% vySupportDOF=[ntop,nbot]+Nn;
% vimposedDOF = ntop(2:end-1);
% 
% vSupportDOF = [vxSuportDOF,vySupportDOF,vimposedDOF];
% vFreeDOF = setdiff(1:2*Nn,vSupportDOF);
% % end
% 
% % Initialize BCs
% pressureBC=zeros(Nn,1);
% pressureBC(pSupportDOF)=0;
% vBC = zeros(2*Nn,1);
% vBC(vimposedDOF)=0.1;
% qn=zeros(Nn,1);
% % end

% %  cavity Flow pressure on TOP velocity on left
% pSupportDOF = ntop;
% pFreeDOF = setdiff(1:Nn,pSupportDOF);
% 
% vxSuportDOF = [nleft,nright];
% vySupportDOF=[ntop,nbot]+Nn;
% vimposedDOF = nleft(2:end-1)+Nn;
% 
% vSupportDOF = [vxSuportDOF,vySupportDOF,vimposedDOF];
% vFreeDOF = setdiff(1:2*Nn,vSupportDOF);
% % end
% 
% % Initialize BCs
% pressureBC=zeros(Nn,1);
% pressureBC(pSupportDOF)=0;
% vBC = zeros(2*Nn,1);
% vBC(vimposedDOF)=0.1;
% qn=zeros(Nn,1);
% % end