function  [G1, D, G, Mu, Md, Mt, dMu, A22d]=full_scale_operators(dxm, dym, dzm, Ck, Mf, Phi, Re, beta, zk)
 G1= sparse([dxm, zk, zk;
              zk, dym, zk;
              zk, zk, dzm;
              0.5*dym, 0.5* dxm, zk;
              0.5*dzm, zk, 0.5*dxm;
              zk, 0.5*dzm,0.5*dym]); %===Gradient of Velocity
 D= sparse([dxm,  zk, zk, dym, dzm, zk;
           zk, dym,  zk, dzm, zk, dxm;
           zk, zk, dzm,  zk, dxm, dym]); %==Divergence of stress
 G= sparse([dxm; dym; dzm]); %=====Gradient of P   
  

  Mu=[Ck,zk, zk;
       zk,Ck, zk;
       zk, zk, Ck];% mass matrix
  Md=[Ck, zk, zk, zk, zk, zk ;
      zk, Ck, zk, zk, zk, zk ;
      zk, zk, Ck, zk, zk, zk;
      zk, zk, zk, Ck, zk, zk ;
      zk, zk, zk, zk, Ck, zk ;
      zk, zk, zk, zk, zk, Ck ];
Mt=Md;
Mu=(sum(Mu,2));
dMu=sparse(diag(1./Mu));
Md=Re/(2*beta)*diag(sum(Md,2));
Mt=diag(sum(Mt,2));
Mf=Phi'*Mf*Phi;
A22d=[Mf, zk, zk, zk, zk, zk ;
      zk, Mf, zk, zk, zk, zk ;
      zk, zk, Mf, zk, zk, zk;
      zk, zk, zk, Mf, zk, zk ;
      zk, zk, zk, zk, Mf, zk ;
      zk, zk, zk, zk, zk, Mf ];





end
