
function[A11, A12, A13, A21, A22, A23, A31, A32, A33, B1, B2, B3]= SolveAssemble(X20, Hk, dMu, Mt, A22d, NBS, beta, Re, G1, D, G, xi, L5W2, L6W1, L1, nk, vk, dt)

A11=Re*speye(6*nk)-dt*L5W2/L6W1*beta*G1*dMu*D;
A12=-Re*dt*L5W2/L6W1*G1*dMu*D;
A13=Re*dt*L5W2/L6W1*G1*dMu*G;

A21=-2*xi*L5W2*dt^2*beta/Re*G1*dMu*D;
A22=Mt+ A22d - 2*xi*dt^2*L5W2*G1*dMu*D;
A23= 2*xi*dt^2*L5W2/L6W1*G1*dMu*G;

A31= -L5W2*dt*beta/Re*G'*dMu*D ;
A32=- L5W2*dt*G'*dMu*D;  
A33=L5W2*dt*G'*dMu*G;
A33(NBS,:)=0; 
for j=1:length(NBS)
  nbs=NBS(j);
  A33(nbs,nbs)=1;
end


B1= Re*G1*vk;%+ dt*beta/Re*G1*dMu*G1'*X1;
B2=L1*Mt*X20 + L1*dt*Mt*Hk + 2*xi*dt*G1*vk;
B3=L5W2* G'*vk;

 



