function [X1, X2, X3]=SolveGS4(X10, X20, X30, B1, B2, B3, A11, A12, A13, A21, A22, A23, A31, A32, A33, L5W2, L6W1, beta, Re, NBS, nd, nk, eta, yita)
nnx=nd(:,1); nny=nd(:,2); nnz=nd(:,3);
X1=X10;X2=X20;X3=X30;
if eta==1
    n=10;
else
    n=1;
end
A=[A11,A12,A13;
   A21,A22,A23;
   A31,A32,A33];
B=[B1;B2;B3];
%% =====Use Gauss-Seidel iterative way to solve AX=B=====
%% ===n=1 and eta=0 provides GS4 explicit scheme 
for i=1:n
      RHS1= B1 -A13*X3 -yita*A12*X2;%+ dt*beta/Re*G1*dMu*G1'*X1;
      X1 = sparse(A11)\(RHS1);

      RHS2=B2-A21*X1-A23*X3;
      if yita==1
      X2 = sparse(A22)\(RHS2);   
      else
       X2=0*RHS2;
      end
     
      R3= B3-A31*X1-yita*A32*X2;  
      if yita==1
      R3(NBS)=0*2*L5W2/L6W1*beta/Re*(...
            X1(NBS).*nnx(NBS).^2  +  X1(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X1(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
            X1(NBS+3*nk).*nnx(NBS).*nny(NBS) + X1(NBS+nk).*nny(NBS).^2  +  X1(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
            X1(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X1(NBS+5*nk).*nny(NBS).*nnz(NBS) +X1(NBS+2*nk).*nnz(NBS).^2)+...
           yita*(X2(NBS).*nnx(NBS).^2  +  X2(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X2(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
            X2(NBS+3*nk).*nnx(NBS).*nny(NBS) + X2(NBS+nk).*nny(NBS).^2  +  X2(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
            X2(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X2(NBS+5*nk).*nny(NBS).*nnz(NBS) +X2(NBS+2*nk).*nnz(NBS).^2);
      else
          R3(NBS)=0*2*L5W2/L6W1*beta/Re*(...
            X1(NBS).*nnx(NBS).^2  +  X1(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X1(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
            X1(NBS+3*nk).*nnx(NBS).*nny(NBS) + X1(NBS+nk).*nny(NBS).^2  +  X1(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
            X1(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X1(NBS+5*nk).*nny(NBS).*nnz(NBS) +X1(NBS+2*nk).*nnz(NBS).^2);
      end
     X3 = sparse(A33)\(R3);
     if eta==1
         X=[X1;X2;X3];B=[B1;B2;B3];
         R=norm(A*X-B);
         if R<=1e-7
             break
         end
     end
end
X=[X1;X2;X3];
end

























 

