function [G1, D, G, Mu, Md, Mt, dMu, A22d]=full_scale_operators(dxm, dym, dzm, Ck, Mf, Phi, zk)
G1= sparse([dxm, zk, zk; 
                 zk, dym, zk;
                 zk, zk, dzm;
                 0.5*dym, 0.5*dxm, zk;
                 0.5*dzm, zk, 0.5*dxm;
                 zk, 0.5*dzm,0.5*dym]);  %===Gradient of vector
      D= sparse([dxm,  zk, zk, dym, dzm, zk;
                 zk, dym,  zk, dzm, zk, dxm;
                 zk, zk, dzm,  zk, dxm, dym]); %==Divergence of tensor
      G= sparse([dxm; dym; dzm]); %=====Gradient of P   
      Mu=[Ck,zk, zk;
          zk,Ck, zk;
          zk, zk, Ck];% mass matrix of velocity
      Md=[Ck, zk, zk, zk, zk, zk;
          zk, Ck, zk, zk, zk, zk;
          zk, zk, Ck, zk, zk, zk;
          zk, zk, zk, Ck, zk, zk;
          zk, zk, zk, zk, Ck, zk;
          zk, zk, zk, zk, zk, Ck]; % mass matrix of stress
      Mt=Md;  Mu=(sum(Mu,2)); dMu=sparse(diag(1./Mu));
      Mt=diag(sum(Mt,2)); Mf=Phi'*Mf*Phi;
      A22d=[Mf, zk, zk, zk, zk, zk ;
            zk, Mf, zk, zk, zk, zk ;
            zk, zk, Mf, zk, zk, zk;
            zk, zk, zk, Mf, zk, zk ;
            zk, zk, zk, zk, Mf, zk ;
            zk, zk, zk, zk, zk, Mf ];